//+------------------------------------------------------------------+
//|                                                         Luis.mq4 |
//|                               Copyright  2013,  Tjipke de Vries |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013,  Tjipke de Vries"
#property link      "http://forum.mql4.com/54215/"


extern string UserSettings        = "=== User Settings ===";
extern bool   DynamicLotSize      = false;
extern double PercentageToTrade   =   1;
extern double FixedLotSize        = 0.01;
extern double Multiplier          =   4;
extern int    MagicNumber         =  10;
extern int    MaxOrders           =   7;
extern int    Opendistance        =   0;
extern int    OppositeDistance    =   2;
extern int    MinStop             =   1;
extern double StopLoss            =  50;
extern double TakeProfit          =  50;
extern double    MinimumProfit    =   2;




int    TotalOpenEA,TotalBuy,TotalSell,TotalBuyStop,BuyTicket,SellTicket,BuyTrigger,SellTrigger,
       TotalSellStop,TotalBuyLimit,TotalSellLimit,Slippage,MyOrders;
double LotSize,lotstep,lotmin,lotmax,MLots;
bool   BuyAllowed, SellAllowed;

//++++ These are adjusted for 5 digit brokers.
int     pips2points;      // slippage  3 pips    3=points    30=points
double  pips2dbl;         // Stoploss 15 pips    0.015      0.0150
int     Digits.pips;      // DoubleToStr(dbl/pips2dbl, Digits.pips)
//---

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits % 2 == 1)  // DE30=1/JPY=3/EURUSD=5 forum.mql4.com/43064#515262
     {pips2dbl = Point*10; pips2points = 10;   Digits.pips = 1;}
     else {pips2dbl = Point;    pips2points =  1;   Digits.pips = 0;}
     // OrderSend(... Slippage.Pips * pips2points, Bid - StopLossPips * pips2dbl       
      
    if(OrdersTotal() >0 )TotalOpenEA=OrdersTotal(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {//0
//---- Number ONE to DO  ==>  CHECK OPEN TRADES
   if(TotalOpenEA > 0)
     {//1
      TotalOpenEA = 0;
      TotalBuy = 0;
      TotalSell =0;
      TotalBuyStop =0;
      TotalSellStop=0;
      TotalBuyLimit =0;
      TotalSellLimit =0;
      double BuyLots,SellLots,HighestLot;
      for(int i = OrdersTotal()-1; i >= 0 ; i--)
        {//2
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
         if(OrderMagicNumber()!=MagicNumber || OrderSymbol()!=Symbol()) continue;
         TotalOpenEA++;
         if(HighestLot < OrderLots())HighestLot=OrderLots();
         //---- check order type
         if(OrderType()==OP_BUY)
           {//3
            TotalBuy++;
            if(OrderLots()> BuyLots)BuyLots=OrderLots();
           }//3 
         if(OrderType()==OP_SELL)         
           {//4
            TotalSell++;
            if(OrderLots()> SellLots)SellLots=OrderLots();
           }//4
         if(OrderType()==OP_BUYSTOP)
           {//5
            TotalBuyStop++;
            if(OrderLots()> BuyLots)BuyLots=OrderLots();
            }//5
          if(OrderType()==OP_SELLSTOP
            {//6
             TotalSellStop++
             if(OrderLots()> SellLots)BuyLots=OrderLots();
            }//6
          if(OrderType()==OP_BUYLIMIT)
            {//7
             TotalBuyLimit++;
             if(OrderLots()> BuyLots)BuyLots=OrderLots();
            }//7
          if(OrderType()==OP_SELLLIMIT)
            {//8
             TotalSellLimit++;
             if(OrderLots()> SellLots)BuyLots=OrderLots();
            }//8
        }//2
     }// 1                      
//finish this loop for all OrderTypes      
          
        //end loop
        
        
//   if(HighestLot==BuyLots)....
//   if(HighestLot==SellLots)....  

OTLastTick = OTCurrentTick;                      
    OTCurrentTick = TotalOpenEA ; 
                       
    if(OTCurrentTick == 0 && OTLastTick > 0)
      {      
      BuyTrigger = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      }                                  
    if(OTLastTick >= 2                                                
      && OTCurrentTick < OTLastTick
      && OTCurrentTick > 0)
      {
       CloseAllOnSL(); return;            
      }                                                                  
    if(OTCurrentTick > 0 && OTCurrentTick < MaxOrders)OpenOppositeOrder();              
    if(OTCurrentTick == MaxOrders)CloseAll(); 
                   
    if(OTCurrentTick == 0)
      {
       BuyAllowed = true;  
       SellAllowed = true;      
      
   //+------------------------------------------------------------------------------------------------------------------+   
  //Money Management 
  
    if(DynamicLotSize == true)
      {//
      double RiskAmount = AccountBalance() * (PercentageToTrade / 100000);
     
      LotSize = RiskAmount;
      }//
    else LotSize = FixedLotSize;
             
   //+------------------------------------------------------------------------------------------------------------------+      
  // Lot size verification 
      {
       lotmin = MarketInfo(Symbol(),MODE_MINLOT);
       lotmax = MarketInfo(Symbol(),MODE_MAXLOT);
       lotstep = MarketInfo(Symbol(),MODE_LOTSTEP);
                    
       LotSize = MathFloor(LotSize/lotstep) * lotstep;
     
       if(LotSize < lotmin)
        LotSize = lotmin;
       if(LotSize > lotmax)
        LotSize = lotmax;             
      }             
  
   //+------------------------------------------------------------------------------------------------------------------+                                                                                                                                                                                                                                                                                                                                                                            
  // Initial Buy Order Condition to Open
  
      RefreshRates();
   if(Ask > BuyTrigger && BuyAllowed)     
	  {//
	  while(IsTradeContextBusy()) 
	        Sleep(10);
	        RefreshRates();	  		       
     BuyTicket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage*pips2points,0,0,"Initial Buy Order",MagicNumber,0,Green);                
     if(BuyTicket > -1)
          {//
         BuyAllowed = false;SellAllowed = true;                                               
         Print("Initial Buy order placed # ",BuyTicket);
         AddLimitsBuy();                                 
         }//
      else
         {// 
         Print("Initial Buy Order Send failed, order number:",OrderTicket(),"Error:", GetLastError());
         }// 
     return(0);
     }//5
     
   //+------------------------------------------------------------------------------------------------------------------+ 	  
  // Initial Sell Order Condition to Open
  
       RefreshRates();
    if(Bid < SellTrigger && SellAllowed)                       
     {//                                
	  while(IsTradeContextBusy()) 
	        Sleep(10);
	        RefreshRates();					 		
	  SellTicket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage*pips2points,0,0,"Initial Sell Order",MagicNumber,0,Red);	  
	  if(SellTicket > -1)
 		  {//
 		  BuyAllowed = true;SellAllowed = false;                                                 
        Print("Initial Sell order placed # ", SellTicket);    
        AddLimitsSell();              
        }//
     else
        {//
        Print("Initial Sell Order Send failed, order number:",OrderTicket(),"Error:", GetLastError());
        }//      
     return(0);
     }//8          
  }//
  				 				
    //+------------------------------------------------------------------------------------------------------------------+   
   // Order loss compensation 
   
   MLots = 0; 
   for(int cnt = OrdersTotal()-1; cnt >= 0; cnt--)
      {//
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))continue;
         {//
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
            {//
            MyOrders = OrdersTotal();
            LastOrderProfit = OrderProfit();                       
             OrderLots();
         if(MLots <= OrderLots())MLots = NormalizeDouble(OrderLots() * Multiplier,2);                                                    
            }//
         }//      
      }//
         if(MyOrders > 0)Trail();                   
   return(0);
   }//0 
                         
   //+------------------------------------------------------------------------------------------------------------------+ 
  //Add limits after sent order for ECN Brokers)   

   void  AddLimitsBuy()
      {
      OrderSelect(BuyTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();
      
   // Calculate Stop Level Limits
        
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;
           
      RefreshRates();      				       				            
      double UpperStopLevel = Ask + StopLevel;
      double LowerStopLevel = Bid - StopLevel;
            
   // Calculate Stop Loss and Take Profit Limits
      
      if(StopLoss > 0)double BuyStopLoss = OpenPrice - (StopLoss * pips2dbl); 
      if(TakeProfit > 0)double BuyTakeProfit = OpenPrice + (TakeProfit * pips2dbl);
      
   // Verify Sto Loss and Take Profit Minimum Limits 
      
      if(BuyStopLoss > 0 && BuyStopLoss > LowerStopLevel)
        {
          BuyStopLoss = LowerStopLevel - MinStop * pips2dbl;
        }
    //  Buy Order Send Stop Loss and Take Profit
          				      	   
	   if(IsTradeContextBusy())
	      Sleep(10);	
      if(BuyStopLoss > 0 || BuyTakeProfit > 0) 
        {		
        if(!OrderModify(BuyTicket,OpenPrice,BuyStopLoss,BuyTakeProfit,0))
        Print("AddLimitsBuy Failed,order number:",OrderTicket(),"Error:",GetLastError());                            
        }
      } 
    //+------------------------------------------------------------------------------------------------------------------+ 
   //Add limits after sent order (ECN Brokers)   

   void   AddLimitsSell()
      {
      OrderSelect(SellTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();
      
    // Calculate Stop Level Limits 
     
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;
             
	   RefreshRates();
	   double UpperStopLevel = Ask + StopLevel;
	   double LowerStopLevel = Bid - StopLevel;	   
	   
	// Calculate Stop Loss and Take Profit Limits 
	  				      				      
	   if(StopLoss > 0) double SellStopLoss = OpenPrice + (StopLoss * pips2dbl);
	   if(TakeProfit > 0) double SellTakeProfit = OpenPrice - (TakeProfit * pips2dbl);
	   
	// Verify Stop Loss and Take Profit Minimum Limits 
	 
	   if(SellStopLoss > 0 && SellStopLoss < UpperStopLevel)
	     {
	       double SellStopLevel = UpperStopLevel + MinStop * pips2dbl;
	     }
	 //  Sell Order Send Stop loss and Take Profit 
	         					      
	   if(IsTradeContextBusy()) 
	      Sleep(10);	
      if(SellStopLoss > 0 || SellTakeProfit > 0) 
         {		
         if(!OrderModify(SellTicket,OpenPrice,SellStopLoss,SellTakeProfit,0))
         Print("Add LimitsSell Failed,order number:",OrderTicket(),"Error:",GetLastError());
         }                    
      }
     
    //+------------------------------------------------------------------------------------------------------------------+   
   //TrailingStop
       
 void Trail()
    {        
     double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;
     double FreezeLevel = MarketInfo(Symbol(),MODE_FREEZELEVEL);
     double NewStop = StopLevel + FreezeLevel + 0.25;
                                 
      //for(int OrderCounter = OrdersTotal()-1; OrderCounter >= 0; OrderCounter--)
      for(int OrderCounter = 0; OrderCounter <= OrdersTotal()-1; OrderCounter++)                  
         {//23
        if(!OrderSelect(OrderCounter,SELECT_BY_POS))continue;
         if(OrderType()== OP_BUY && OrderSymbol()== Symbol() 
            && OrderMagicNumber()== MagicNumber)                                                                        
            {//24
               RefreshRates();          
             if(OrderStopLoss() < Bid - (NewStop * pips2dbl) && Bid - OrderOpenPrice() > (MinimumProfit * pips2dbl))             
               {//25
                  RefreshRates();
               if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid - (NewStop * pips2dbl), OrderTakeProfit(),0,Yellow))
                Print("Buy TrailingStop Failed, order number:",OrderTicket(),"Error:",GetLastError());
               }//25
             }//24
           }//23          
           if(OrderType()==OP_SELL && OrderSymbol()== Symbol() 
              && OrderMagicNumber()== MagicNumber)
              {//26               
                 RefreshRates();
             if(OrderStopLoss() > Ask + (NewStop * pips2dbl)  && OrderOpenPrice() - Ask > (MinimumProfit * pips2dbl)) 
                {//2
                    RefreshRates();
                 if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask + (NewStop * pips2dbl) ,OrderTakeProfit(),0,Yellow))             
                 Print("Sell TrailingStop Failed, order number:",OrderTicket(),"Error:",GetLastError());
               }//27                                         
           // return;     
          }//26   
    }

 //+------------------------------------------------------------------------------------------------------------------+ 
/*
// GetTicketFromHistory

int GetTicketFromHistory(string sym,int mn,int orderposinhistory=0)
  {
   bool debug=false;
   if(debug)Print("Orders in history: ", OrdersHistoryTotal());
   int ticket,count=1,i;
   datetime orderclosedates[];
   for(i=OrdersHistoryTotal()-1;i>=0;i--)
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
      if(debug)Print("OrderSymbol: ",OrderSymbol(),"; OrderMagicNumber: ",OrderMagicNumber(),
                     " ;OrderType: ",OrderType(),"; OrderTicket: ",OrderTicket(),
                     "; OrderCloseTime: ",TimeToStr(OrderCloseTime()),";"); 
      if((OrderMagicNumber()  ==mn)
         &&(OrderSymbol()     ==sym)
         &&(OrderType()==OP_BUY||OrderType()==OP_SELL))
         {                       
         ArrayResize(orderclosedates,count);
         orderclosedates[count-1]=OrderCloseTime();
         count++;
      }
   }
   if(ArraySize(orderclosedates)> 0)//<--------------------------------------------------------------changed from 0 to 1 in test
   {
      if(debug)Print("ArraySize (Orders found): ",ArraySize(orderclosedates));
      if(ArraySize(orderclosedates)>orderposinhistory)
      {                         
         ArraySort(orderclosedates,WHOLE_ARRAY,0,MODE_DESCEND);
         for(i=OrdersHistoryTotal()-1;i>=0;i--)
         {
            if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
            if(OrderCloseTime()==orderclosedates[orderposinhistory])
            {
               ticket=OrderTicket();
               if(debug)Print("Orderticket for order ",orderposinhistory," in history: ",ticket);
               break;      
            }
         }    
      }
      else
      {
         if(debug)Print("Not enough matching orders in history!");
      }
   }   
   return(ticket);   
}
*/
  //+------------------------------------------------------------------------------------------------------------------+ 
 void OpenOppositeOrder()
    {     
    int Op;
    
   for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)
      {//
      if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))continue;          
         {//
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)           
            {//16
             Op = OrderType();
             RefreshRates();            
         if(Op == OP_BUY && Ask < (OrderOpenPrice() - (OppositeDistance*pips2dbl)) && SellAllowed)  
                                 
               {//  
                while(IsTradeContextBusy()) 
                      Sleep(10);
                      RefreshRates();                             
                SellTicket = OrderSend(Symbol(), OP_SELL, MLots, Bid, Slippage*pips2points, 0, 0, "Open Opposite Sell Order", MagicNumber, 0, Red);
                if(SellTicket > -1) 
                  {//
                  BuyAllowed=true;SellAllowed=false;                                          
                  Print("Opposite Sell order placed # ", SellTicket);                
                  AddLimitsSell();                                    
                  return;
                  }//
               else
                  {//
                  Print("Opposite Sell Order Failed,order number:",OrderTicket(),"Error:",GetLastError());
                  }//
                }// 
                RefreshRates();           
            if(Op == OP_SELL &&  Bid > OrderOpenPrice() + (OppositeDistance*pips2dbl) && BuyAllowed)
                       
              {//  
               while(IsTradeContextBusy()) 
                    Sleep(10);
	                 RefreshRates();	          	        
               BuyTicket = OrderSend(Symbol(), OP_BUY, MLots, Ask, Slippage*pips2points, 0, 0, " Open Opposite Buy Order", MagicNumber, 0, Green); 
               if(BuyTicket > -1)
                  {//
                  BuyAllowed=false;SellAllowed=true;                                                          
                  Print("Opposite Buy order placed # ", BuyTicket);                             
                  AddLimitsBuy();
               return;
                  }//
               else
                  {//  
                  Print("Opposite Buy Order Failed, order number:",OrderTicket(),"Error:",GetLastError());
                  }//   
               }//
            }//
         }//    
      }//      
    }//
    
    //+------------------------------------------------------------------------------------------------------------------+ 
   /*
   void CloseAllOnSL()
   {
   int OrdType, GLError;
   double OrderClosed;
      	
   //int LastClosedTicket=GetTicketFromHistory(Symbol(),MagicNumber);  
  // if(LastClosedTicket > 0)                                          
      {                                                  
      //Print("LastClosedTicket=",LastClosedTicket);                   
      //if(OrderSelect(LastClosedTicket,SELECT_BY_TICKET))             
         {
         if(OrderClosePrice() - OrderStopLoss() == 0) CloseAll();             
        //// if(MathAbs(OrderTakeProfit()- OrderClosePrice())>            
           // MathAbs(OrderStopLoss()- OrderClosePrice()))CloseAll();                                
            {        
           // Print("Order with ticketnr: ", LastClosedTicket,
                 // " hit SL! Close all open orders");                                   
             } 
          }     
       } 
     }
   */        
 //+------------------------------------------------------------------------------------------------------------------+   
      
                void CloseAllOnSL()
                   {              
                 for(int OrderInLoss = OrdersTotal()-1; OrderInLoss >= 0; OrderInLoss--)       
                    if(OrderSelect(OrderInLoss, SELECT_BY_POS, MODE_HISTORY)
                       && OrderMagicNumber()== MagicNumber 
                       && OrderSymbol()== Symbol())                                                    
                     {
                     if(OrderCloseTime ()!= 0)
                       {
                        CloseAll();
                        break;
                       }	                  	            
                     }               
                   }               
                    
   //+------------------------------------------------------------------------------------------------------------------+ 
            
           void CloseAll()
              {
               int OrdType;
               int GLError;
  
                for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
                if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
                   && OrderMagicNumber()== MagicNumber 
                   && OrderSymbol()== Symbol())                                       
                   {//31
                   OrdType = OrderType();
                   if(OrdType == OP_BUY || OrdType==OP_SELL)
                      {//32
                     while(IsTradeContextBusy()) 
                        Sleep(10);  
	                  RefreshRates();
	            
                     if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),Slippage*pips2points, Yellow))                
                        {
                        GLError = GetLastError();
                        Print("Error Closing Order, error # ", GLError, " for ticket: ", OrderTicket());  
                        }
                      }//32               
                    }//31      
                 }//30 
              
 //+------------------------------------------------------------------------------------------------------------------+ 


 
 